#
# detect_ppe_from_image.py
#
# Created by Nguyen Quang Duy on Tue Dec 19 2023
#

from deepvision.common.typed_dict import AllOptionsDict
from dataclasses import dataclass
from deepvision.client import PPEClient


class DetectPPEFromImage:

    @dataclass
    class Request:
        api_key: str
        image_path: str

    def __init__(self, domain: str, port: str, api_key: str):
        self.detect_ppe_from_image: PPEClient = PPEClient(
            api_key=api_key,
            domain=domain,
            port=port
        )

    def execute(self, request: Request, options: AllOptionsDict = {}) -> dict:
        result: dict = self.detect_ppe_from_image.post(
            request.image_path, options)
        return result
