#
# add_subject.py
#
# Created by Nguyen Quang Duy on Mon Dec 18 2023
#

from deepvision.common.typed_dict import EmbedProbOptionsDict
from dataclasses import dataclass
from deepvision.client import FaceClient


class AddSubject:

    @dataclass
    class Request:
        collection_name: str
        image_path: list
        image_id: list
        subject_id: str
        subject_name: str

    def __init__(self, domain: str, port: str, api_key: str):
        self.face: FaceService = FaceService(api_key=api_key,
                                             domain=domain,
                                             port=port)

    def execute(self, request: Request) -> dict:
        result: dict = self.face.add_subject(
            request.collection_name, request.subject_id,
            request.subject_name, request.image_id, request.image_path)
        return result
