#
# delete_all_examples_of_subject_by_name.py
#
# Created by Nguyen Quang Duy on Mon Dec 18 2023
#

from dataclasses import dataclass
from deepvision.client import FaceClient


class DeleteAllExamplesOfSubjectByName:

    @dataclass
    class Request:
        api_key: str
        collection_name: str
        subject_name: str

    def __init__(self, api_key: str, domain: str, port: str):
        self.face: FaceClient = FaceClient(api_key=api_key,
                                             domain=domain,
                                             port=port)

    def execute(self, request: Request) -> dict:
        result: dict = self.face.remove_all_example_of_subject_by_name(
            request.collection_name, request.subject_name)
        return result
