#
# delete_example_by_id.py
#
# Created by Nguyen Quang Duy on Mon Dec 18 2023
#

from dataclasses import dataclass
from deepvision.client import FaceClient


class DeleteExampleById:

    @dataclass
    class Request:
        api_key: str
        collection_name: str
        image_id: str

    def __init__(self, domain: str, port: str, api_key: str):
        self.face: FaceService = FaceService(api_key=api_key,
                                             domain=domain,
                                             port=port)

    def execute(self, request: Request):
        result: dict = self.face.remove_example(
            request.collection_name, request.image_id)
        return result
