#
# delete_subject_by_name.py
#
# Created by Nguyen Quang Duy on Mon Dec 18 2023
#

from dataclasses import dataclass

from deepvision.client import FaceClient


class DeleteSubjectByName:

    @dataclass
    class Request:
        collection_name: str
        subject_name: str

    def __init__(self, domain: str, port: str, api_key: str):
        self.face: FaceService = FaceService(api_key=api_key,
                                             domain=domain,
                                             port=port)

    def execute(self, request: Request) -> dict:
        result: dict = self.face.remove_subject_by_name(
            request.collection_name, request.subject_name)
        return result
