#
# detect_subject_from_image.py
#
# Created by Nguyen Quang Duy on Mon Dec 18 2023
#

from deepvision.common.typed_dict import ExpandedOptionsDict
from dataclasses import dataclass
from deepvision.client.face import FaceDetectorClient


class DetectFaceFromImage:

    @dataclass
    class Request:
        api_key: str
        image_path: str

    def __init__(self, domain: str, port: str, api_key: str):
        self.face: FaceDetectorClient = FaceDetectorClient(
            api_key=api_key,
            domain=domain,
            port=port
        )

    def execute(self, request: Request, options: ExpandedOptionsDict = {}) -> dict:
        result: dict = self.face.post()
        return result
