#
# get_subjects.py
#
# Created by Nguyen Quang Duy on Mon Dec 18 2023
#

from dataclasses import dataclass
from deepvision.client import FaceClient


class GetSubjects:

    @dataclass
    class Request:
        collection_name: str

    def __init__(self, domain: str, port: str, api_key: str):
        self.face = FaceClient(api_key=api_key,
                                      domain=domain,
                                      port=port)

    def execute(self, request: Request) -> dict:
        result: dict = self.face.list_subjects(request.collection_name)
        return result
