#
# recognize_subject_from_image.py
#
# Created by Nguyen Quang Duy on Mon Dec 18 2023
#

from deepvision.common.typed_dict import AllOptionsDict
from dataclasses import dataclass
from deepvision.client.face import FaceRecognizeClient


class RecognizeFaceFromImage:

    @dataclass
    class Request:
        api_key: str
        image_path: str

    def __init__(self, api_key: str):
        self.recognize_face_from_image: FaceRecognizeClient = FaceRecognizeClient(
            api_key=api_key
        )

    def execute(self, request: Request, options: AllOptionsDict = {}) -> dict:
        result: dict = self.recognize_face_from_image.post(
            request.image_path, options)
        return result
