#
# update_subject.py
#
# Created by Nguyen Quang Duy on Mon Dec 18 2023
#

from dataclasses import dataclass, asdict
from deepvision.client import FaceClient


class UpdateSubject:

    @dataclass
    class Request:
        collection_name: str
        new_subject_name: str
        subject_id: str

    def __init__(self, domain: str, port: str, api_key: str):
        self.subject: FaceClient = FaceClient(api_key=api_key,
                                      domain=domain,
                                      port=port)

    def execute(self, request: Request) -> dict:
        result: dict = self.subject.rename_subject(
            request.collection_name, request.subject_id, request.new_subject_name)
        return result
