#
# verification_subject_from_image.py
#
# Created by Nguyen Quang Duy on Mon Dec 18 2023
#

from deepvision.common.typed_dict import ExpandedOptionsDict
from dataclasses import dataclass
from deepvision.client.face import FaceVerificationClient


class VerificationFaceFromImage:

    @dataclass
    class Request:
        api_key: str
        image_path: str
        image_id: str

    def __init__(self, domain: str, port: str, api_key: str):
        self.verify_face_from_image: FaceVerificationClient = FaceVerificationClient(
            api_key=api_key,
            domain=domain,
            port=port
        )

    def execute(self, request: Request, options: ExpandedOptionsDict = {}):
        result: dict = self.verify_subject_from_image.post(request.image_path,
                                                        request.image_id, options)
        return result
