#
# verifiy_subject_from_images.py
#
# Created by Nguyen Quang Duy on Mon Dec 18 2023
#

from deepvision.client.face import FaceVerifyClient
from deepvision.common.typed_dict import ExpandedOptionsDict
from dataclasses import dataclass


class VerifyFaceFromImage:

    @dataclass
    class Request:
        api_key: str
        source_image_path: str
        target_image_path: str

    def __init__(self, domain: str, port: str, api_key: str):
        self.verify_subject_from_image: FaceVerifyClient = FaceVerifyClient(
            api_key=api_key,
            domain=domain,
            port=port
        )

    def execute(self, request: Request, options: ExpandedOptionsDict = {}):
        result: dict = self.verify_subject_from_image.post(request.source_image_path,
                                                        request.target_image_path,
                                                        options)
        return result
