#
# add_example_of_product.py
#
# Created by Nguyen Quang Duy on Mon Dec 18 2023
#

from deepvision.common.typed_dict import EmbedProbOptionsDict
from dataclasses import dataclass
from deepvision.client.product import ProductClient


class AddExampleOfProduct:

    @dataclass
    class Request:
        collection_name: str
        api_key: str
        image_path: str
        image_id: str
        product_id: str
        product_name: str

    def __init__(self, domain: str, port: str, api_key: str):
        self.add_example_of_product: ProductClient = ProductClient(
            api_key=api_key,
            domain=domain,
            port=port,
            options={}
        )

    def execute(self, request: Request, options: EmbedProbOptionsDict = {}) -> dict:
        result: dict = self.add_example_of_product.add_example(
            request.collection_name, request.product_id,
            request.product_name, request.image_id, request.image_path)
        return result


