#
# add_product.py
#
# Created by Nguyen Quang Duy on Mon Dec 18 2023
#

from dataclasses import dataclass
from deepvision.client.product import ProductClient


class AddProduct:

    @dataclass
    class Request:
        collection_name: str
        image_path: list
        image_id: list
        product_id: str
        product_name: str
    
    def __init__(self, domain: str, port: str, api_key: str):
        self.add_product_client: ProductClient = ProductClient(
            api_key=api_key,
            domain=domain,
            port=port,
            options={}
        )

    def execute(self, request: Request) -> dict:
        result: dict = self.add_product_client.add_product(
            request.collection_name, request.product_id,
            request.product_name, request.image_id, request.image_path)
        return result