#
# count_product_from_image.py
#
# Created by Nguyen Quang Duy on Tue Dec 19 2023
#

from deepvision.common.typed_dict import AllOptionsDict
from dataclasses import dataclass
from deepvision.client.product import ProductCountClient


class CountProductFromImage:

    @dataclass
    class Request:
        collection_name: str
        api_key: str
        image_path: str

    def __init__(self, domain: str, port: str, api_key: str):
        self.product_count_client: ProductCountClient = ProductCountClient(
            api_key=api_key,
            domain=domain,
            port=port
        )

    def execute(self, request: Request, options: AllOptionsDict = {}) -> dict:
        result: dict = self.product_count_client.post(request.collection_name,
                                                      request.image_path,
                                                      options)
        return result
