#
# detect_product_from_image.py
#
# Created by Nguyen Quang Duy on Mon Dec 18 2023
#

from deepvision.common.typed_dict import ExpandedOptionsDict
from dataclasses import dataclass
from deepvision.client.product import ProductDetectorClient


class DetectProductFromImage:

    @dataclass
    class Request:
        api_key: str
        image_path: str

    def __init__(self, domain: str, port: str, api_key: str):
        self.detect_product_from_image: ProductDetectorClient = ProductDetectorClient(
            api_key=api_key,
            domain=domain,
            port=port
        )

    def execute(self, request: Request, options: ExpandedOptionsDict = {}) -> dict:
        result: dict = self.detect_product_from_image.post(
            request.image_path)
        return result
