#
# get_subjects.py
#
# Created by Nguyen Quang Duy on Mon Dec 18 2023
#

from dataclasses import dataclass
from deepvision.client.product import ProductClient


class GetProducts:

    @dataclass
    class Request:
        collection_name: str

    def __init__(self, domain: str, port: str, api_key: str):
        self.product: ProductClient = ProductClient(
            api_key=api_key,
            domain=domain,
            port=port,
            options={}
        )

    def execute(self, request: Request) -> dict:
        result: dict = self.product.list_products(request.collection_name)
        return result
