#
# recognize_product_from_image.py
#
# Created by Nguyen Quang Duy on Mon Dec 18 2023
#

from deepvision.common.typed_dict import AllOptionsDict
from dataclasses import dataclass
from deepvision.client.product import ProductRecognizeClient


class RecognizeProductFromImage:

    @dataclass
    class Request:
        collection_name: str
        api_key: str
        image_path: str

    def __init__(self, domain: str, port: str, api_key: str):
        self.recognize_product_from_image: ProductRecognizeClient = ProductRecognizeClient(
            api_key=api_key,
            domain=domain,
            port=port
        )

    def execute(self, request: Request, options: AllOptionsDict = {}) -> dict:
        result: dict = self.recognize_product_from_image.post(request.collection_name,
                                                              request.image_path, options)
        return result
