#
# update_product.py
#
# Created by Nguyen Quang Duy on Mon Dec 18 2023
#

from dataclasses import dataclass, asdict
from deepvision.client.product import ProductClient


class UpdateProductByName:

    @dataclass
    class Request:
        collection_name: str
        product_name: str
        new_product_name: str
        

    def __init__(self, domain: str, port: str, api_key: str):
        self.product: ProductClient = ProductClient(
            api_key=api_key,
            domain=domain,
            port=port,
            options={}
        )

    def execute(self, request: Request) -> dict:
        result: dict = self.product.rename_product_by_name(
            request.collection_name, request.product_name, request.new_product_name)
        return result
