#
# verification_product_from_image.py
#
# Created by Nguyen Quang Duy on Mon Dec 18 2023
#

from deepvision.common.typed_dict import ExpandedOptionsDict
from dataclasses import dataclass
from deepvision.client.product import ProductVerificationClient


class VerificationProductFromImage:

    @dataclass
    class Request:
        collection_name: str
        api_key: str
        image_path: str
        product_id: str

    def __init__(self, domain: str, port: str, api_key: str):
        self.verify_product_from_image: ProductVerificationClient = ProductVerificationClient(
            api_key=api_key,
            domain=domain,
            port=port
        )

    def execute(self, request: Request, options: ExpandedOptionsDict = {}):
        result: dict = self.verify_product_from_image.post(request.collection_name, request.image_path,
                                                        request.product_id, options)
        return result
