
from setuptools import find_packages, setup

with open("README.md", "r") as fh:
    long_description = fh.read()

setup(
    name='deepvision-sdk',
    packages=find_packages(exclude=("examples",)),
    version='0.1.1',
    description='DeepVision Python SDK makes face recognition into your application even easier.',
	long_description=long_description,
	long_description_content_type="text/markdown",
    author='Nguyen Quang Duy',
    keywords=[
        "DeepVision",
        "Computer Vision",
        "SDK"
    ],
    install_requires=[
        'requests-toolbelt==0.9.1',
        'scipy',
        'chromadb',
        'pandas'
    ],
    classifiers=[
        'Development Status :: 5 - Production/Stable',
        'Intended Audience :: Developers',
        'Intended Audience :: Science/Research',
        'Intended Audience :: Information Technology',
        'Topic :: Software Development',
        'Topic :: Software Development :: Build Tools',
        'Topic :: Software Development :: Libraries',
        'Topic :: Scientific/Engineering :: Image Recognition',
        'Topic :: Scientific/Engineering :: Artificial Intelligence',
        'Programming Language :: Python :: 3',
        'Programming Language :: Python :: 3.9'
    ],
)
